<template>
  <div class="generate">
    <ReturnButton
      title="Regresar"
      :offsetArrow="20"
      :spanTitle="3"
      class="text-end"
    ></ReturnButton>
    <div class="titleSection">Asientos de Amortización</div>
    <div class="max__width__40">
      <div class="data__generate">
        <div class="camp__data my-i-70 flex just-center">
          <p @click="consolear()" class="camp__data--text mr-40"><strong>PERIODO:</strong></p>
          
          <el-date-picker
            v-model="datePeriod"
            format="MMM-yyyy"
            type="month"
            placeholder="Seleccionar periodo"
            @change="selectDate"
            ref="datePicker"
           
          >
          </el-date-picker>
        </div>
      </div>
      <div class="just-center actions">
        <el-button
          class="style__button"
          @click="generateReport"
          type="primary"
           :disabled="isDisabledBtn"
        >
          GENERAR AMORTIZACIONES
          <i class="el-icon-arrow-right" style="color: white; fontweight: bold"></i>
        </el-button>

        <el-button
          @click="generateSeat({route:'seat', text: 'CONSUMO MATERIAL FILMICO', reverse: false})"
          class="style__button"
          type="primary"
           :disabled="isDisabledBtn"
        >
          GENERAR ASIENTO
          <i class="el-icon-arrow-right" style="color: white; fontweight: bold"></i>
        </el-button>

        <el-button
          @click="generateSeat({route:'seat/revertSeat',text:'REVERSIÓN DE CONSUMO FILMICO', reverse: true})"
          class="style__button"
          type="primary"
           :disabled="isDisabledBtn"
        >
          REVERTIR ASIENTO
          <i class="el-icon-arrow-right" style="color: white; fontweight: bold"></i>
        </el-button>
      </div>
    </div>
    <AppModal
      :show-dialog.sync="aproveModal"
      v-if="aproveModal"
      nameClass="dialog-red"
      :rutImg="require(`@/assets/images/suspicious.svg`)"
      :textBold="textModalBox.danger"
      :parrafo="textModalBox.text"
      v-on:eventBtn="aproveModal = false"
      btn1="Aceptar"
      btn2="Cancelar"
      typeBtn1="danger" 
      @btnEvent="acceptEvent"
      @eventBtn="cancelEvent"
    />
    <AppModal
      :show-dialog.sync="sitGen"
      v-if="sitGen"
      nameClass="dialog-orange"
      :rutImg="require(`@/assets/images/happy.svg`)"
      textBold="¡Buen trabajo!"
      :parrafo="textModal"
      v-on:eventBtn="sitGen = false"
    />

    <AppModal
      :show-dialog.sync="errorSit"
      v-if="errorSit"
      nameClass="dialog-orange"
      :rutImg="require(`@/assets/images/suspicious.svg`)"
      textBold="¡Error al generar asiento!"
      :parrafo="textModal"
      v-on:eventBtn="errorSit = false"
    />

    <AppModalLoader
      :loaderModal="loaderModal"
      v-if="loaderModal"
      textModal=""   
      v-on:eventBtn="loaderModal = false" 
    />
  </div>
</template>
<script>
import Header from '@/components/amortizationOfContract/Header.vue'
import ReturnButton from '@/components/ReturnButton.vue'
import AppModal from '@/components/AppModal.vue'
import AppModalLoader from '@/components/AppModalLoader.vue'
import { HTTP } from '@/main.js'
import { mapState } from 'vuex'
import moment from 'moment'
moment.locale('es')

export default {
  name: 'SitGenerate',
  components: {
    Header,
    AppModal,
    ReturnButton,
    AppModalLoader
  },
  data() {
    return {
      datePeriod: null,
      showData: false,
      sitGen: false,
      textModal: 'Se ha generado un asiento.',
      aproveModal: false,
      textModalBox:{
        danger: "",
        text: ""
      },
      errorSit: false,
      loaderModal: false,
      params: null
    }
  },
  computed: {
    dateSelect() {
      return moment(this.datePeriod).format('DD/MM/YYYY')
    },
    isDisabledBtn () {
      return this.datePeriod !== null  ? false : true
    }
  },
  methods: {
    consolear(){
      console.log({fecha: this.date,hora: this.hour})
    },
    async acceptEvent(){
      const {route, text, reverse} = this.params
      this.aproveModal = false
      this.loaderModal = true

      let dateCopy = moment(JSON.stringify(this.dateSelect), 'DD/MM/YYYY')
      let lastDay = moment(dateCopy._d).endOf('month').format('DD/MM/YYYY')
      let periodNum = moment(dateCopy._d).endOf('month').format('MM/YYYY')
      let periodTransform = this.transformDate(dateCopy._d, 'YY')
      let periodoText = this.transformDate(dateCopy._d, 'YYYY').split('-').join(' ')
      let date = moment(new Date()).format('DD/MM/YYYY')
      let dateSpecific = moment().format('DD/MM/YYYY HH:MM:SS')
      let info = 
        {
          dateSpecific,
          lastDay,
          period: periodTransform,
          periodNum,
          date: lastDay,
          created_by: '1111',
          user_currency: 'User',
          segment_company: '01',
          segment4: '000000',
          segment6: '0000000',
          segment7: '0000000',
          segment8: '000000',
          segment9: '000000',
          reference: `${text} ${periodoText}`,
          set_book: 1001,
        }
      
        let {data}  = await HTTP.post(route, info)        
        console.log({data})
      
        let hour = moment(new Date()).format('h:mm a').valueOf()

        console.log({date, hour})
        if(data && data != "ErrorCombination" && data != "MonthClose") {
          this.loaderModal = false
          if(reverse == false){
            this.sitGen = true
            if(data.countSeats > 0){
              this.textModal = `Se ha generado ${data.countSeats} asiento(s) correctamente el ${date} a las ${hour}.`
            }
            else{
              this.textModal = `Todos los asientos de este periodo ya han sido insertados.`
            }

          }else{
            this.sitGen = true
            this.textModal = `Se ha revertido ${data.countSeatsRemove} asiento(s) correctamente el ${date} a las ${hour}.`
          }
        }
        else if(data == "ErrorCombination") {
          this.errorSit = true
          this.textModal = "No coinciden las combinaciones en los segmentos, consultar con el área de contabilidad."
        }
        else if(data == "MonthClose") {
          this.errorSit = true
          this.textModal = "Este mes no esta habilitado, consultar con el área de contabilidad."
        }
    },
  
    cancelEvent(){
      this.aproveModal = false
    },
    selectDate(val) {
      let element = JSON.parse(
        JSON.stringify(
          this.$refs.datePicker.$children[0].$el.children[0].className
        )
      )
      let elements = element.split(',')
      let haveClass = elements.filter((e) => e == 'text__uppercase')
      if (val !== null && haveClass.length == 0) {
        elements.push('text__uppercase')
      } else {
        let index = elements.findIndex((e) => e === 'text__uppercase')
        elements.splice(1, index)
      }
      this.$refs.datePicker.$children[0].$el.children[0].className = elements.join(
        ' '
      )
    },
    transformDate(date, string) {
      let result
      if (date !== undefined && date !== '') {
        let myDate = new Date(date)
        let day = moment(date).endOf('month').format('DD')
        let year = moment(date).format(string)
        let month = [
          'ENE',
          'FEB',
          'MAR',
          'ABR',
          'MAY',
          'JUN',
          'JUL',
          'AGO',
          'SEP',
          'OCT',
          'NOV',
          'DIC',
        ][myDate.getMonth()]
        let dateText = `${month}-${year}`
        result = dateText
      } else {
        result = ''
      }
      return result
    },
    generateSeat(val) {
      this.aproveModal = true
      const {route, text, reverse} = val
      this.params = val
      if(reverse == false){
        this.textModalBox.danger = `IMPORTANTE: <br>
        Antes de generar el(los) asientos contables es
        necesario que valide la información resultante del proceso con el área contable de ser necesario.`
        this.textModalBox.text = `De estar forma evitaremos posibles extornos contables. ¿Está seguro(a) de querer generar los asientos?`
      }else {
        this.textModalBox.danger = `IMPORTANTE:  <br>
        Estas a punto de revertir los asientos de este periodo.`
        this.textModalBox.text = `Verifica que este proceso sea necesario para continuar.`
      }
      
    },
    async generateReport() {
      this.loaderModal = true
      let hour = moment(new Date()).format('h:mm a').valueOf()
      let date = moment(new Date()).format('DD/MM/YYYY')

      let dateCopy = moment(JSON.stringify(this.dateSelect), 'DD/MM/YYYY')
      let lastDay = moment(dateCopy._d).endOf('month').format('DD/MM/YYYY')
      const {data} = await HTTP.post('seat/report/', { date: lastDay })
      if(data) {
        this.loaderModal = false
        this.sitGen = true
        this.textModal = `Se han generado las amortizaciones correctamente el ${date} a las ${hour}.`
      }
    },
    selectDate() {
      let dateCopy = moment(JSON.stringify(this.dateSelect), 'DD/MM/YYYY')
      let dateTransform = this.transformDate(dateCopy._d, 'YYYY')
    },
  },
}
</script>
<style lang="scss" scoped>
.generate {
  height: auto;
  margin: 0;
  margin-top: 100px;
  padding: 0 100px;
}
.sub__title {
  font-size: 22px;
  color: #333;
}
.data__generate {
  .camp__data {

    align-items: center;

    color: #333;
  }
}
.text__uppercase {
  text-transform: uppercase !important;
}
.actions{
  display: flex;
  flex-direction: column;
  .style__button{
    max-width: 250px;
    margin: 5px 0;
    font-size: 14px;
    display: flex;
    justify-content: space-between;
  }
}

</style>
